;TVO - (C) Text video overlay generator by D. Lazarov 

	list p=18f258

#include "P18F258.inc"

;config  reg. (27 MHz HS mode)
__CONFIG _CONFIG1H,0x22
__CONFIG _CONFIG2L,0x0E
__CONFIG _CONFIG2H,0x00

;port definitions
#define	SYNCV_PIN		PORTB,0
#define	BKGD			PORTA,3
#define	LEDR			PORTA,0
#define	LEDG			PORTA,1
#define	TV_SYST_PIN		PORTA,2
#define	SPD1_PIN		PORTB,4
#define	SPD3_PIN		PORTB,6
#define	LINE_UP_PIN		PORTB,2
#define	LINE_DOWN_PIN	PORTB,3
#define	BKGD_SET_PIN	PORTB,7
#define	COM_IN_PIN		PORTB,1
#define SHIFTBYTEADDR 	SCRL_DATA_START_ADDR+SCRL_TXT_LNGTH
;internal flags used to show the
;state after certain operations 
#define DONE_FL			WORKFLAGS,0	;done			
#define BKGD_FL			WORKFLAGS,2	;bkgd
#define	BKGD_CALC_FL	WORKFLAGS,3	;set after bkgd for every row is calculated
#define TIMEOUT_FL		WORKFLAGS,4 ;timeout
#define HALF_SCR_FL		WORKFLAGS,5 ;half screen
;bits of the first received byte determine 
;what kind of data follow
#define SCRL_TXT_FL		MESSAGE,0; scrolling text data
#define ST_TXT_FL		MESSAGE,1; static text data
#define FONT_FL			MESSAGE,4; font data

SCRL_DATA_START_ADDR	equ 	0x20  ;20h-2B0h=scroll txt space
ST_DATA_START_ADDR 		equ		0x2C0 ;2C0h-4F0h=static txt space
COM_DATA_STARTADDR		equ 	0x500 ;500h-580h=serial data buffer
LINESNR 				equ		d'16' ;TV lines/row nr.; rows nr.
SCRL_TXT_LNGTH			equ		d'40' ;scrolling chars nr./row
ST_TXT_LNGTH			equ		d'35' ;static chars nr./row
MSG_LNGTH_H_VAL			equ		0x04  ;1KB block step

;user registers
	CBLOCK		0x000
HPOS
ROW
LINES
MESSAGE		
CHAR_CNT	
WORKFLAGS
REC_BUFF
PAUSE
COUNTREG
ROTATION
BLOCK
BLOCKS_NR
INDEX
BYTE
TEMP1L
TEMP1H
MSGLNGTH
MSGLNGTH_H
MESSAGE_TEMP
WREG_TMP
SPD_REG
SPD_CNT
PCKTS_NR
PCKTS_NR_TEMP
BKGDBYTE1
BKGDBYTE2
BKGDBYTE1_TEMP
BKGDBYTE2_TEMP	
	ENDC
	
	ORG	0x1C00
	fill 0x0000,46
	ORG	0x1C46
	da "Text video overlay generator v.3  ",0
	ORG	0x1C6A
	da "with PIC18F258           ",0
	ORG	0x1C86
	fill 0x0000,1AA 
	org  0xF00000  	;initializes EEPROM
	de 0xE6,0xFF,0x02,0; st. txt default after programming

;A00h-1A00h=font data space
;1C00h-7C00=saved static/scrolling text	space

	ORG	0x0000
   	BRA START
	ORG	0x0008
	BRA COMPORT	;used for serial reception
	ORG	0x0018
	BRA DISPLAY	;used for displaying text

START	BCF INTCON, GIE; initialisations
	CLRF INTCON2
	MOVLW  b'01001000'
	MOVWF INTCON3
	BTFSC RCON, POR
	CALL LINESET
	MOVLW b'10011111'
	MOVWF RCON
	CLRF PORTA
	CLRF PORTB
 	CLRF PORTC
	MOVLW  b'00000111'
	MOVWF ADCON1
	MOVLW  b'11110100'
	MOVWF TRISA
	SETF TRISB
	MOVLW  b'01010001'
	MOVWF TRISC
	BCF OSCCON,SCS	
	BCF WDTCON,SWDTEN ;bit 0
	MOVLW  b'11101000'
	MOVWF T0CON
	MOVLW b'10110001'
	MOVWF T1CON
TXINIT	CLRF SPBRG
	MOVLW  b'10110010'
	MOVWF TXSTA
	BSF RCSTA, SPEN
	MOVLW  b'00100000'
	MOVWF INTCON
	MOVLW  d'2'
	MOVWF EEADR ;reads the data type to be displayed 
	BCF EECON1, EEPGD
	BCF EECON1, CFGS
	BSF EECON1, RD
	MOVFF EEDATA, MESSAGE	
	BTFSC SCRL_TXT_FL
	BRA N1
	BSF ST_TXT_FL
	CALL SAVED_TXT_ADDR_INIT
	MOVLW d'16'  
	MOVWF LINES
	MOVLW ST_TXT_LNGTH  
	MOVWF CHAR_CNT
	LFSR 0, ST_DATA_START_ADDR
LOADTXT TBLRD*+
	MOVFF TABLAT, POSTINC0
	DECFSZ CHAR_CNT
	BRA LOADTXT
	MOVLW ST_TXT_LNGTH  
	MOVWF CHAR_CNT	
	DECFSZ	LINES
	BRA LOADTXT
	CALL BKGDCALC
	BRA N2
N1	MOVLW d'1'
	MOVWF EEADR ;reads the nr. of 1k blocks
	BCF EECON1, EEPGD
	BCF EECON1, CFGS
	BSF EECON1, RD
	MOVFF EEDATA, PCKTS_NR	
	CALL CR_INIT	
	CALL FILLRAM
N2	CLRF EEADR ;reads the text position
	BCF EECON1, EEPGD
	BCF EECON1, CFGS
	BSF EECON1, RD
	MOVFF EEDATA, HPOS	
	CALL LINE_UP
	MOVLW d'2'
	MOVWF COUNTREG
LED	BSF LEDR
	BCF LEDG
	CALL SEC
	BCF LEDR
	BSF LEDG
	CALL SEC
	DECFSZ COUNTREG,1
	BRA LED
	BCF LEDG
	BSF INTCON, GIEH
MAIN_LOOP  	BTFSC SYNCV_PIN ;checks if vert. sync. 
	BRA $-2					;pulses are present
	BCF INTCON, GIEL
	MOVFF HPOS, TMR0L
	CALL WAIT300us 
	CALL EXT_PINS	
	BTFSC SCRL_TXT_FL
	CALL SPEED	
	LFSR 0, SCRL_DATA_START_ADDR
	BTFSC ST_TXT_FL
	CALL F_ROW
	MOVLW LINESNR
	MOVWF LINES
	BCF INTCON, TMR0IF
	BSF INTCON, GIEL
	BRA MAIN_LOOP
F_ROW BTFSS BKGD_CALC_FL	
	CALL BKGDCALC
	MOVLW 0x0A
	MOVWF TBLPTRH
	BCF HALF_SCR_FL
	LFSR 0,ST_DATA_START_ADDR
	BTFSC TV_SYST_PIN
	LFSR 0,ST_DATA_START_ADDR+(2*ST_TXT_LNGTH)
	MOVLW d'16'
	BTFSC TV_SYST_PIN
	MOVLW d'14'
	MOVWF ROW
	BCF BKGD_FL
	BTFSC BKGD_SET_PIN
	RETURN
	MOVFF BKGDBYTE1_TEMP, BKGDBYTE1
	MOVFF BKGDBYTE2_TEMP, BKGDBYTE2
	BTFSS TV_SYST_PIN
	BRA $+6
	RRNCF BKGDBYTE1,1
	RRNCF BKGDBYTE1,1
	BTFSC BKGDBYTE1,0
	BSF BKGD_FL
	RRNCF BKGDBYTE1,1
	RETURN
EXT_PINS CLRF SPD_REG
	BTFSS SPD1_PIN
	BSF SPD_REG,0
	BTFSS SPD3_PIN
	BSF SPD_REG,2
	BTFSS LINE_DOWN_PIN
	CALL LINE_DOWN
	BTFSS LINE_UP_PIN
	CALL LINE_UP
	RETURN
COMPORT 	BCF INTCON, GIEL
	BCF INTCON, GIEH
	BCF BKGD
	BSF LEDR
	BCF LEDG
	MOVFF MESSAGE, MESSAGE_TEMP
	CALL REC_B
	CLRF MESSAGE
	MOVLW 0x01
	CPFSEQ REC_BUFF
	BRA D2
	BSF SCRL_TXT_FL
	BRA D4
D2  MOVLW 0x02
	CPFSEQ REC_BUFF
	BRA D3 
	BSF FONT_FL
	BRA D4
D3	BSF ST_TXT_FL
D4 	BTFSC SCRL_TXT_FL
	CALL THICKER
	BTFSC ST_TXT_FL
	CALL ST_TXT
	BTFSC FONT_FL
	CALL FONT
	BCF STKPTR, STKFUL
	BCF STKPTR, STKUNF
	MOVLW 1h
	CPFSGT STKPTR
	BRA $+6
	POP
	BRA $-6
	CPFSEQ STKPTR
	BSF STKPTR, 0
	MOVLW low MAIN_LOOP	
	MOVWF TOSL
	MOVLW high MAIN_LOOP	
	MOVWF TOSH
	MOVLW upper MAIN_LOOP	
	MOVWF TOSU
	BCF LEDR
	BCF INTCON3,INT1IF
	BSF INTCON, GIEH
	RETURN
LINESET	CLRF EEADR;saves the text position on the screen
	MOVFF HPOS, EEDATA
	CALL WR_EEPR
	MOVLW d'2'
	MOVWF EEADR
	MOVFF MESSAGE, EEDATA;saves the type 
	CALL WR_EEPR		 ;of data to be displayed
	BTFSC ST_TXT_FL
	CALL TXTSAVE
	RETURN
WR_EEPR	BCF EECON1, EEPGD
	BCF EECON1, CFGS
	BSF EECON1, WREN
	MOVLW h'55'
	MOVWF EECON2
	MOVLW h'AA'
	MOVWF EECON2
	BSF EECON1, WR
	BCF EECON1, WREN
	BTFSC EECON1,WR 
	BRA $-2
	RETURN
LINE_UP INCF HPOS
	MOVLW d'205'
	BTFSC ST_TXT_FL
	MOVLW d'225'
	CPFSGT HPOS
	RETURN
	MOVWF HPOS
	RETURN
LINE_DOWN	DECFSZ HPOS
	RETURN
	MOVLW d'1'
	MOVWF HPOS
	RETURN
WAIT300us	MOVLW d'13';delay needed to avoid entering
	CALL PER		;the routine many times during 
	RETURN			;the same V pulse
TXTSAVE MOVLW d'10'
	MOVWF BLOCKS_NR
	CALL SAVED_TXT_ADDR_INIT
	CALL ERASE
	MOVLW d'70'
	MOVWF BLOCK  
	MOVLW d'1'
	MOVWF BLOCKS_NR  
	CALL SAVED_TXT_ADDR_INIT
 	LFSR 0,ST_DATA_START_ADDR
	TBLRD*-
	CALL BLOCKW
	RETURN	
DISPLAY	BCF INTCON, GIEL
	BSF LEDG
	MOVLW 0xFE
	CALL PER
	MOVLW SCRL_TXT_LNGTH
	BTFSC ST_TXT_FL
	MOVLW ST_TXT_LNGTH
	MOVWF CHAR_CNT
	BTFSC BKGD_FL	
	BSF BKGD
	BTFSC SCRL_TXT_FL
	CALL TXSEND
	BTFSC ST_TXT_FL
	CALL TXSEND1
	SETF TMR0L
	DCFSNZ LINES, 1
	CLRF TMR0L
	BTFSC SCRL_TXT_FL
	MOVF POSTINC0,1
	BCF BKGD
	BCF LEDG
	BTFSC ST_TXT_FL
	CALL HFRESH
	BTFSS SYNCV_PIN
	RETURN
	BCF INTCON, TMR0IF
	RETFIE
TXSEND	BTFSS PIR1, TXIF
	BRA $-2
	MOVFF POSTINC0, TXREG
	DECFSZ CHAR_CNT, 1
	BRA TXSEND
	RETURN
TXSEND1 MOVFF POSTINC0,TBLPTRL
	TBLRD*
	MOVFF TABLAT,TXREG
	DECFSZ CHAR_CNT,1
	BRA TXSEND1
	INCF TBLPTRH,1
	MOVLW ST_TXT_LNGTH
	SUBWF FSR0L,1
	BTFSS STATUS,C
	DECF FSR0H,1
	RETURN
HFRESH SETF TMR0L
	TSTFSZ LINES
	RETURN
	BTFSC BKGD_SET_PIN
	BRA NEXT1
	BCF BKGD_FL
	MOVLW d'9'
	CPFSGT ROW
	BSF HALF_SCR_FL
	BTFSC HALF_SCR_FL
	BRA BKGD2 
	BTFSC BKGDBYTE1,0
	BSF BKGD_FL
	RRNCF BKGDBYTE1,1
	BRA NEXT1
BKGD2	BTFSC BKGDBYTE2,0
	BSF BKGD_FL
	RRNCF BKGDBYTE2,1
NEXT1	MOVLW 0x0A
	MOVWF TBLPTRH
	MOVLW ST_TXT_LNGTH
	ADDWF FSR0L,1
	BTFSC STATUS,C
	INCF FSR0H,1
	MOVLW LINESNR
	MOVWF LINES 
	DECFSZ ROW,1
	RETURN
	CLRF TMR0L
	RETURN
SCRL_RST	MOVFF MESSAGE_TEMP, MESSAGE 
	BTFSS SCRL_TXT_FL
	RETURN
	CALL CR_INIT
	RETURN 
THICKER	CALL REC_B
	MOVFF REC_BUFF, PCKTS_NR
	CALL SAVED_TXT_ADDR_INIT
	MOVLW d'6'
	MOVWF PCKTS_NR_TEMP 
ONEKBLOCKS	MOVLW d'64'
	MOVWF BLOCKS_NR
	CALL ERASE
	DECFSZ PCKTS_NR_TEMP	
	BRA ONEKBLOCKS
	CALL SAVED_TXT_ADDR_INIT
	MOVFF PCKTS_NR, PCKTS_NR_TEMP
	TBLRD*- 
ONEKBLOCKS1	MOVLW d'8'
	MOVWF BLOCKS_NR
	CALL WRITE
	DECFSZ PCKTS_NR_TEMP	
	BRA ONEKBLOCKS1	
	CALL CR_INIT
	CALL FILLRAM
	MOVLW d'1'
	MOVWF EEADR;saves the number of 1k blocks
	MOVFF PCKTS_NR, EEDATA;into EEPROM
	BCF EECON1, EEPGD
	BCF EECON1, CFGS
	BSF EECON1, WREN
	MOVLW h'55'
	MOVWF EECON2
	MOVLW h'AA'
	MOVWF EECON2
	BSF EECON1, WR
	BCF EECON1, WREN
	BTFSC EECON1,WR 
	BRA $-2
	RETURN
FILLRAM SETF BYTE; RAM delete
	MOVLW LINESNR
	MOVWF LINES
	LFSR 0,SCRL_DATA_START_ADDR
PAT1	MOVLW SCRL_TXT_LNGTH+1
	MOVWF CHAR_CNT
	MOVF BYTE,0
	MOVWF POSTINC0
	DECFSZ CHAR_CNT,1
	BRA $-4
	DECFSZ LINES,1
	BRA PAT1
	RETURN
CR_INIT	CALL SAVED_TXT_ADDR_INIT
	MOVFF TBLPTRH, TEMP1H
	MOVFF TBLPTRL, TEMP1L
	MOVLW MSG_LNGTH_H_VAL
	MULWF PCKTS_NR
	MOVFF PRODL, MSGLNGTH_H 	
	CLRF MSGLNGTH
	MOVLW d'8'
	MOVWF ROTATION
	MOVLW d'32'
	MOVWF INDEX
	BSF DONE_FL
	RETURN
SPEED BTFSC SPD_REG,0
	BRA SPD0
	BTFSC SPD_REG,2
	CALL CRAWL
 	CALL CRAWL
	RETURN
SPD0	DCFSNZ SPD_CNT
	BRA $+4
	RETURN
	CALL CRAWL
	MOVLW d'2'
	MOVWF SPD_CNT
	RETURN
CRAWL BCF BKGD_FL 
	BTFSS BKGD_SET_PIN
	BSF BKGD_FL 	
	BTFSS DONE_FL
	BRA SHIFT
	TSTFSZ MSGLNGTH
	BRA STRING
	TSTFSZ MSGLNGTH_H
	BRA STRING
	LFSR 1,SHIFTBYTEADDR
	MOVLW d'16'
	MOVWF LINES
DEL SETF WREG
	MOVWF INDF1
	MOVLW SCRL_TXT_LNGTH+1	
	CALL FSR1INC
	DECFSZ LINES,1
	BRA  DEL
	DECFSZ INDEX
	BRA EPTY
	CALL CR_INIT
	RETURN
EPTY	MOVLW d'8'
	MOVWF ROTATION
	BCF DONE_FL
	BRA SHIFT
STRING	LFSR 1,SHIFTBYTEADDR
	MOVFF TEMP1H, TBLPTRH
	MOVFF TEMP1L, TBLPTRL 
BUILD1	TBLRD*+
	MOVF TABLAT,0
	MOVFF TBLPTRH, TEMP1H
 	MOVFF TBLPTRL, TEMP1L
	TSTFSZ WREG
	BRA UPDAT
	DECFSZ BYTE
	BRA C_CAR
	CLRF MSGLNGTH
	CLRF MSGLNGTH_H
	BSF DONE_FL
	RETURN
UPDAT MOVFF WREG, WREG_TMP  
	MOVLW d'4'
	MOVWF BYTE
	MOVFF WREG_TMP,WREG  
C_CAR	MOVFF WREG,TBLPTRL
	MOVLW 0x0A; same as TBLPTRH from FNT_ADDR_INIT
	MOVWF TBLPTRH
 	MOVLW LINESNR
	MOVWF COUNTREG
	MOVLW SCRL_TXT_LNGTH+1		
READ1	TBLRD*
	MOVFF TABLAT,INDF1
	CALL FSR1INC
	INCF TBLPTRH,1	
	DECFSZ COUNTREG,1
	BRA READ1
	MOVLW d'8'
	MOVWF ROTATION
	DECF MSGLNGTH,1
	BTFSS STATUS, C
	DECF MSGLNGTH_H,1
	BCF DONE_FL
SHIFT	MOVLW d'16'
	MOVWF LINES
	LFSR 0,SCRL_DATA_START_ADDR
	LFSR 1,SCRL_DATA_START_ADDR+1
	MOVLW SCRL_TXT_LNGTH+1
	MOVWF CHAR_CNT
	RRNCF INDF0,1
SET4	BCF STATUS,C
	RRCF POSTINC1,1
	BTFSC STATUS,C	
	BSF INDF0,7
	MOVF POSTINC0,1
	DECFSZ CHAR_CNT,1
	BRA SET4
	MOVWF CHAR_CNT
	DECFSZ LINES,1
	BRA SET4
	DECFSZ ROTATION,1
	RETURN
	BSF DONE_FL
	RETURN
REC_L BTFSC ST_TXT_FL	
	BRA T_OUT
REC_T	CALL REC_B
	BTFSS ST_TXT_FL
	MOVFF REC_BUFF, POSTINC0
	DECFSZ COUNTREG, 1
	BRA REC_L
	RETURN
T_OUT	BCF PIR1,TMR1IF
	MOVLW 0xF2
	MOVWF TMR1H	
	MOVLW 0x43
	MOVWF TMR1L
T_OUT1 BTFSS COM_IN_PIN
	BRA REC_T
	BTFSS PIR1,TMR1IF
	BRA T_OUT1
	BSF TIMEOUT_FL
	RETURN
REC_B	BTFSC COM_IN_PIN
	BRA $-2
	CLRF REC_BUFF 
	MOVLW d'8'
	MOVWF BYTE
	MOVLW 0xA9
	CALL PER
	MOVLW 0x51
SAMPLE	CALL PER
	RRNCF REC_BUFF,1;LSB is the first bit
	BTFSC COM_IN_PIN
	BSF REC_BUFF,7
	DECFSZ BYTE,1
	BRA SAMPLE
	CALL PER
	RETURN
PER	BCF PIR1,TMR1IF
	SETF TMR1H 
	MOVWF TMR1L
	BTFSS PIR1,TMR1IF
	BRA $-2
	RETURN
SEC	MOVLW d'13'
	MOVWF PAUSE
SEC1	BCF PIR1,TMR1IF
	CLRF TMR1H
	CLRF TMR1L
	BTFSS PIR1,TMR1IF
	BRA $-2
	DECFSZ PAUSE,1
	BRA SEC1
	RETURN
FONT	MOVLW d'64'
	MOVWF BLOCKS_NR
	CALL FNT_ADDR_INIT
	CALL ERASE
	MOVLW d'32'
	MOVWF BLOCKS_NR  
	CALL FNT_ADDR_INIT
 	TBLRD*-
	CALL WRITE
	CALL SCRL_RST
	BTFSC ST_TXT_FL
	RETURN
FNT_ADDR_INIT	CLRF TBLPTRU
	MOVLW 0x0A 
	MOVWF TBLPTRH
	CLRF TBLPTRL
	RETURN
SAVED_TXT_ADDR_INIT	CLRF TBLPTRU
	MOVLW 0x1C 
	MOVWF TBLPTRH
	CLRF TBLPTRL
	RETURN
ERASE	BSF EECON1,EEPGD
	BCF EECON1,CFGS
	BSF EECON1,WREN
	BSF EECON1,FREE
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
	NOP
	BCF EECON1,WREN
	MOVLW d'64'
	ADDWF TBLPTRL,1
	BTFSC STATUS,C
	INCF TBLPTRH,1
	DECFSZ BLOCKS_NR,1
	BRA ERASE 
	RETURN
WRITE	LFSR 0, COM_DATA_STARTADDR
	MOVLW d'128'
	MOVWF COUNTREG
	CALL REC_L
	LFSR 0, COM_DATA_STARTADDR
	MOVLW d'16' 
	MOVWF BLOCK
BLOCKW	MOVLW d'8'
	MOVWF COUNTREG
	CALL WRITE_N
	DECFSZ BLOCK,1
	BRA BLOCKW
	DECFSZ BLOCKS_NR,1
	BRA WRITE
	RETURN
WRITE_N	MOVF POSTINC0,0
	MOVWF TABLAT
	NOP
	TBLWT+*
	DECFSZ COUNTREG,1
	BRA WRITE_N
	BSF EECON1,EEPGD
	BCF EECON1,CFGS
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
	NOP
	BCF EECON1,WREN
	RETURN
ST_TXT	BCF TIMEOUT_FL
	LFSR 0,ST_DATA_START_ADDR+0x20D
CHAR	MOVLW 0x0D
	CPFSEQ REC_BUFF
	BRA $+4
	BRA PUSH_ROWS_UP	
	MOVLW 0x0A
	CPFSEQ REC_BUFF
	BRA $+4	
	BRA PUSH_ROWS_UP
	MOVFF REC_BUFF,POSTINC0
	MOVLW 0xF0
	CPFSEQ FSR0L
	BRA CHAR1
	BCF BKGD_CALC_FL
	RETURN
CHAR1	MOVLW d'1'
	MOVWF COUNTREG		
	CALL REC_L
	BTFSS TIMEOUT_FL
	BRA CHAR
	BCF BKGD_CALC_FL
	RETURN
PUSH_ROWS_UP	LFSR 0,ST_DATA_START_ADDR
	LFSR 1,ST_DATA_START_ADDR+ST_TXT_LNGTH
ROWS_UP	MOVFF POSTINC1, POSTINC0
	MOVLW 0xF0
	CPFSEQ FSR1L
	BRA ROWS_UP
	MOVLW 0x04
	CPFSEQ FSR1H
	BRA ROWS_UP
	MOVLW ST_TXT_LNGTH
	MOVWF COUNTREG
	CLRF POSTINC0
	DECFSZ COUNTREG
	BRA $-4
	BCF PIR1,TMR1IF
	MOVLW 0xFA
	MOVWF TMR1H	
	MOVLW 0xBE
	MOVWF TMR1L
	BTFSS PIR1,TMR1IF
	BRA $-2
	LFSR 0,ST_DATA_START_ADDR+0x20D
	BRA CHAR1
BKGDCALC CLRF BKGDBYTE1
	CLRF BKGDBYTE2	
	MOVLW ST_TXT_LNGTH
	MOVWF CHAR_CNT
	MOVLW d'8'
	MOVWF ROW
	LFSR 0,ST_DATA_START_ADDR
HALF1  TSTFSZ POSTINC0
	BSF BKGDBYTE1,0
	DECFSZ CHAR_CNT
	BRA HALF1
	MOVLW ST_TXT_LNGTH
	MOVWF CHAR_CNT
	RRNCF BKGDBYTE1,1
	DECFSZ ROW,1
	BRA HALF1
	MOVLW d'8'
	MOVWF ROW
HALF2 TSTFSZ POSTINC0
	BSF BKGDBYTE2,0
	DECFSZ CHAR_CNT
	BRA HALF2
	MOVLW ST_TXT_LNGTH
	MOVWF CHAR_CNT
	RRNCF BKGDBYTE2,1
	DECFSZ ROW,1
	BRA HALF2
	MOVFF BKGDBYTE1, BKGDBYTE1_TEMP
	MOVFF BKGDBYTE2, BKGDBYTE2_TEMP
	BSF BKGD_CALC_FL
	RETURN
FSR1INC	ADDWF FSR1L,1
	BTFSC STATUS,C
	INCF FSR1H,1
	RETURN
	END